function y = alpha(B, K, T, r, q, v)

% B = barrier
% K = strike
% T = Evaluation times
% r = Risk free rate
% q = Dividend yield
% v = volatility

N = length(T);

for i =1:N
    t(i) = T(N-i+1);
end
 
a(N) = -BSCall2T(B, K, t(N-1), t(N), r, q, v) / BSCall2T(B, B, t(N-1), t(N), r, q, v);

for i=N-1:-1:2
	Sum = 0;
	for j=i+1:N
		Sum = Sum + a(j)*BSCall2T(B, B, t(i-1), t(j), r, q, v);
	end
    a(i) = -(Sum + BSCall2T(B, K, t(i-1), t(N), r, q, v)) / BSCall2T(B, B, t(i-1), t(i), r, q, v);
end
a(1) = 0;
 
y = a;
 
 
function y = BSCall2T(S,K,t,T,r,q,v)
mat = T-t;
d1 = (log(S/K) + (r-q-v^2/2)*mat)/v/sqrt(mat);
d2 = d1 - v*sqrt(mat);
y = S*exp(-q*mat)*normcdf(d1) - K*exp(-r*mat)*normcdf(d2);

